//+------------------------------------------------------------------+
//|                                                       iCorel.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Orange
#property indicator_color3 Yellow
#property indicator_color4 SpringGreen
#property indicator_color5 DeepSkyBlue
#property indicator_color6 Blue
#property indicator_color7 Plum
#property indicator_color8 NavajoWhite
//---- input parameters
extern int     Correl.Period  =  14;  
extern string  Base.Symbol;
extern string  S1.Name        = "EURUSD";
extern bool    S1.Allowed     = true;          
extern string  S2.Name        = "AUDUSD"; 
extern bool    S2.Allowed     = true;            
extern string  S3.Name        = "USDCHF";  
extern bool    S3.Allowed     = true;           
extern string  S4.Name        = "USDJPY";  
extern bool    S4.Allowed     = true;          
extern string  S5.Name        = "USDCAD";  
extern bool    S5.Allowed     = true;  
extern string  S6.Name        = "";  
extern bool    S6.Allowed     = false;   
extern string  S7.Name        = "";  
extern bool    S7.Allowed     = false;   
extern string  S8.Name        = "";  
extern bool    S8.Allowed     = false;         
        

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   if(StringTrimLeft(StringTrimRight(Base.Symbol))=="")Base.Symbol = Symbol();
  
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
   
   SetIndexLabel(0,S1.Name+"/"+Base.Symbol);
   SetIndexLabel(1,S2.Name+"/"+Base.Symbol);   
   SetIndexLabel(2,S3.Name+"/"+Base.Symbol);
   SetIndexLabel(3,S4.Name+"/"+Base.Symbol);     
   SetIndexLabel(4,S5.Name+"/"+Base.Symbol);
   SetIndexLabel(5,S6.Name+"/"+Base.Symbol);   
   SetIndexLabel(6,S7.Name+"/"+Base.Symbol);
   SetIndexLabel(7,S8.Name+"/"+Base.Symbol);     
   
   IndicatorDigits(2);
   
   SetIndexDrawBegin(0,Correl.Period);
   SetIndexDrawBegin(1,Correl.Period);   
   SetIndexDrawBegin(2,Correl.Period);   
   SetIndexDrawBegin(3,Correl.Period);   
   SetIndexDrawBegin(4,Correl.Period);
   SetIndexDrawBegin(5,Correl.Period);   
   SetIndexDrawBegin(6,Correl.Period);   
   SetIndexDrawBegin(7,Correl.Period);
   
   IndicatorShortName("iCorr");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   Me();
  
   datetime daytimes[];
   
   static bool err;
   
   ArrayCopySeries(daytimes,MODE_TIME,Base.Symbol,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+Base.Symbol);
         err=true;
         return(0);
      }
   if(S1.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S1.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S1.Name);
         err=true;
         return(0);
      }   
   }
   if(S2.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S2.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S2.Name);
         err=true;
         return(0);
      }   
   }      
   if(S3.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S3.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S3.Name);
         err=true;
         return(0);
      }   
   }      
   if(S4.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S4.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S4.Name);
         err=true;
         return(0);
      }   
   }    
   if(S5.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S5.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S5.Name);
         err=true;
         return(0);
      }   
   }    
   if(S6.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S6.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S6.Name);
         err=true;
         return(0);
      }   
   }    
   if(S7.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S7.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S7.Name);
         err=true;
         return(0);
      }   
   }    
   if(S8.Allowed){
   ArrayCopySeries(daytimes,MODE_TIME,S8.Name,0);
      if(GetLastError()==4066){
         IndicatorShortName("    "+S8.Name);
         err=true;
         return(0);
      }   
   }    
   int limit=Bars-IndicatorCounted();//       
      if(err){
         err=false;
         limit=Bars;
         IndicatorShortName("iCorr");
      }  

      if(S1.Allowed){
         for(int i=0;i<limit;i++){
            ExtMapBuffer1[i]=Correl(Base.Symbol,S1.Name,i);
         }       
      }
      if(S2.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer2[i]=Correl(Base.Symbol,S2.Name,i);   
         }      
      }
      if(S3.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer3[i]=Correl(Base.Symbol,S3.Name,i);   
         }      
      }
      if(S4.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer4[i]=Correl(Base.Symbol,S4.Name,i);   
         }      
      }
      if(S5.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer5[i]=Correl(Base.Symbol,S5.Name,i);   
         }      
      }
      if(S6.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer6[i]=Correl(Base.Symbol,S6.Name,i);   
         }      
      }
      if(S7.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer7[i]=Correl(Base.Symbol,S7.Name,i);   
         }      
      }
      if(S8.Allowed){
         for(i=0;i<limit;i++){
            ExtMapBuffer8[i]=Correl(Base.Symbol,S8.Name,i);   
         }      
      }  
 
   return(0);
  }
//+------------------------------------------------------------------+

double Correl(string base,string hedge,int shift){  
   double u1=0,l1=0,s1=0;
   int base_bn=iBarShift(base,0,Time[shift],false);
   int hedge_bn=iBarShift(hedge,0,Time[shift],false);   
   
      for(int i = Correl.Period - 1; i >= 0; i--){
         u1 +=(iClose(base,0,base_bn+i)-iMA(base,0,Correl.Period,0,MODE_SMA,PRICE_CLOSE,base_bn+i))* (iClose(hedge,0,hedge_bn+i)-iMA(hedge,0,Correl.Period,0,MODE_SMA,PRICE_CLOSE,hedge_bn+i));
         l1 += MathPow(iClose(base,0,base_bn+i)-iMA(base,0,Correl.Period,0,MODE_SMA,PRICE_CLOSE,base_bn+i),2);
         s1 += MathPow(iClose(hedge,0,hedge_bn+i)-iMA(hedge,0,Correl.Period,0,MODE_SMA,PRICE_CLOSE,hedge_bn+i),2);
      }
   double dMathSqrt = MathSqrt(l1*s1);
   if(dMathSqrt > 0) 
       return(u1 / dMathSqrt);
  }

void Me(){
   color ColorArray[49];
   ArrayInitialize(ColorArray,RoyalBlue);
   ColorArray[43]=DodgerBlue;
   ColorArray[44]=LightSkyBlue;    
   ColorArray[45]=LightBlue;   
   ColorArray[46]=LightBlue;   
   ColorArray[47]=LightSkyBlue;
   ColorArray[48]=DodgerBlue;   

   static int ColorIndex;
   //Integer: for-good-letters@yandex.ru
   IndicatorShortName("iCorr");
   int WinNum=WindowFind("iCorr");
   string MyString="Integer: for-good-letters@yandex.ru";
   int k=0;
   int tmpColorIndex;
   tmpColorIndex=ColorIndex;
      for(int i=0;i<StringLen(MyString);i++){
         if(StringSubstr(MyString,i,1)=="y"){
            k+=6;
         }
         fObjLabel("iCorr_"+i,4+i*7+k,2,StringSubstr(MyString,i,1),2,ColorArray[tmpColorIndex],8,WinNum);
         tmpColorIndex++;
         if(tmpColorIndex>=ArraySize(ColorArray))tmpColorIndex=0;         
      }
   ColorIndex--;
   if(ColorIndex<0)ColorIndex=ArraySize(ColorArray)-1;
}  
  
void fObjLabel(
   string aObjectName,     // 1 
   int aX,                 // 2 
   int aY,                 // 3 
   string aText,           // 4 
   int aCorner=0,          // 5    0  1
                           //          2  3
   color aColor=Red,       // 6 
   int aFontSize=8,        // 7  
   int aWindowNumber=0,    // 8 
   string aFont="Arial",   // 9 
   bool aBack=false        // 10 
   ){     
   
   // fObjLabel("",10,10,"");
   // fObjLabel("",10,10,"",0,Red,8,0,"Arial",false);
   static int oc; 
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_LABEL,aWindowNumber,0,0);
         oc++;
         if(oc>35)Alert("Dont delete my labels!");
      }      
   ObjectSet(aObjectName,OBJPROP_XDISTANCE,aX);
   ObjectSet(aObjectName,OBJPROP_YDISTANCE,aY);   
   ObjectSetText(aObjectName,aText,aFontSize,aFont,aColor);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);
   ObjectSet(aObjectName,OBJPROP_CORNER,aCorner);   
}

